Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcini.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcini.F90	(revision 2528)
@@ -14,12 +14,10 @@
    !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
-   !!   trc_ini :   Initialization for passive tracer
+   !!   trc_init :   Initialization for passive tracer
    !!----------------------------------------------------------------------
    USE oce_trc
    USE trc
-   USE trp_trc
    USE trcrst
-   USE trcctl
-   USE trclec
+   USE trcnam          ! Namelist read
    USE trcini_cfc      ! CFC      initialisation
    USE trcini_lobster  ! LOBSTER  initialisation
@@ -28,30 +26,26 @@
    USE trcini_my_trc   ! MY_TRC   initialisation
    USE trcdta   
-#if defined key_off_tra 
+#if defined key_offline
    USE daymod
 #endif
-   USE zpshde_trc      ! partial step: hor. derivative 
+   USE zpshde          ! partial step: hor. derivative   (zps_hde routine)
    USE in_out_manager  ! I/O manager
    USE prtctl_trc      ! Print control passive tracers (prt_ctl_trc_init routine)
    USE lib_mpp         ! distributed memory computing library
+   USE lib_fortran     ! 
    
    IMPLICIT NONE
    PRIVATE
    
-   PUBLIC   trc_ini   ! called by opa
+   PUBLIC   trc_init   ! called by opa
 
     !! * Substitutions
 #  include "domzgr_substitute.h90"
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 1.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
   
 CONTAINS
    
-   SUBROUTINE trc_ini
+   SUBROUTINE trc_init
       !!---------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_ini  ***
+      !!                     ***  ROUTINE trc_init  ***
       !!
       !! ** Purpose :   Initialization of the passive tracer fields 
@@ -69,23 +63,38 @@
 
       IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) 'trc_ini : initial set up of the passive tracers'
+      IF(lwp) WRITE(numout,*) 'trc_init : initial set up of the passive tracers'
       IF(lwp) WRITE(numout,*) '~~~~~~~'
 
       !                 ! masked grid volume
       DO jk = 1, jpk
-         cvol(:,:,jk) = e1t(:,:) * e2t(:,:) * fse3t(:,:,jk) * tmask(:,:,jk) * tmask_i(:,:)
+         cvol(:,:,jk) = e1t(:,:) * e2t(:,:) * fse3t(:,:,jk) * tmask(:,:,jk) 
       END DO
 
       ! total volume of the ocean
-#if ! defined key_off_degrad
-      areatot = SUM( cvol(:,:,:) )
+#if ! defined key_degrad
+      areatot = glob_sum( cvol(:,:,:) )
 #else
-      areatot = SUM( cvol(:,:,:) * facvol(:,:,:) ) ! degrad option: reduction by facvol
+      areatot = glob_sum( cvol(:,:,:) * facvol(:,:,:) )  ! degrad option: reduction by facvol
 #endif
-      IF( lk_mpp )   CALL mpp_sum( areatot )     ! sum over the global domain  
 
-                                  CALL trc_lec      ! READ passive tracers namelists
+                                  CALL trc_nam      ! read passive tracers namelists
 
-                                  CALL trc_ctl      ! control consistency between parameters, cpp key
+      ! restart for passive tracer (input)
+      IF( ln_rsttr ) THEN
+         IF(lwp) WRITE(numout,*) '       read a restart file for passive tracer : ', cn_trcrst_in
+         IF(lwp) WRITE(numout,*) ' '
+      ELSE
+         IF(lwp) WRITE(numout,*)
+         DO jn = 1, jptra
+            IF( lwp .AND. lutini(jn) )  &                  ! open input FILE only IF lutini(jn) is true
+            &  WRITE(numout,*) '        read an initial file  for passive tracer number :', jn, ' traceur : ', ctrcnm(jn) 
+         END DO
+      ENDIF
+
+      IF( ln_dm2dc .AND. ( lk_pisces .OR. lk_lobster ) )    &
+         &       CALL ctl_stop( ' The diurnal cycle is not compatible with PISCES or LOBSTER  ' )
+
+      IF( nn_cla == 1 )   &
+         &       CALL ctl_stop( ' Cross Land Advection not yet implemented with passive tracer ; nn_cla must be 0' )
 
       IF( lk_lobster ) THEN   ;   CALL trc_ini_lobster      ! LOBSTER bio-model
@@ -109,26 +118,28 @@
       ENDIF
 
-      IF( .NOT. ln_rsttr ) THEN 
-#if defined key_off_tra
-         CALL day_init      ! calendar
-#endif
-# if defined key_dtatrc
-         ! Initialization of tracer from a file that may also be used for damping
-         CALL trc_dta( nittrc000 )
-         DO jn = 1, jptra
-            IF( lutini(jn) )   trn(:,:,:,jn) = trdta(:,:,:,jn) * tmask(:,:,:)   ! initialisation from file if required
-         END DO
-# endif
-         trb(:,:,:,:) = trn(:,:,:,:)
+      IF( ln_rsttr ) THEN
+        !
+        IF( lk_offline )  neuler = 1   ! Set time-step indicator at nit000 (leap-frog)
+        CALL trc_rst_read              ! restart from a file
+        !
       ELSE
-         !
-         CALL trc_rst_read      ! restart from a file
-         !
+        IF( lk_offline )  THEN
+           neuler = 0                  ! Set time-step indicator at nit000 (euler)
+           CALL day_init               ! set calendar
+        ENDIF
+        IF( lk_dtatrc )  THEN
+           CALL trc_dta( nit000 )      ! Initialization of tracer from a file that may also be used for damping
+           DO jn = 1, jptra
+              IF( lutini(jn) )   trn(:,:,:,jn) = trdta(:,:,:,jn) * tmask(:,:,:)   ! initialisation from file if required
+           END DO
+        ENDIF 
+        trb(:,:,:,:) = trn(:,:,:,:)
+        ! 
       ENDIF
-
+ 
       tra(:,:,:,:) = 0.
       
-      IF( ln_zps .AND. .NOT. lk_trc_c1d )   &              ! Partial steps: before horizontal gradient of passive
-      &                     CALL zps_hde_trc( nittrc000, trb, gtru, gtrv )       ! tracers at the bottom ocean level
+      IF( ln_zps .AND. .NOT. lk_c1d )   &              ! Partial steps: before horizontal gradient of passive
+      &                     CALL zps_hde( nit000, jptra, trn, gtru, gtrv )       ! tracers at the bottom ocean level
 
 
@@ -136,12 +147,10 @@
       trai = 0.e0
       DO jn = 1, jptra
-#if ! defined key_off_degrad
-         trai = trai + SUM( trn(:,:,:,jn) * cvol(:,:,:) )
+#if ! defined key_degrad
+         trai = trai + glob_sum( trn(:,:,:,jn) * cvol(:,:,:) )
 #else
-         trai = trai + SUM( trn(:,:,:,jn) * cvol(:,:,:) * facvol(:,:,:) ) ! degrad option: reduction by facvol
+         trai = trai + glob_sum( trn(:,:,:,jn) * cvol(:,:,:) * facvol(:,:,:) ) ! degrad option: reduction by facvol
 #endif
       END DO      
-      IF( lk_mpp )   CALL mpp_sum( trai )     ! sum over the global domain  
-
 
       !                 ! control print
@@ -162,5 +171,5 @@
       ENDIF
 
-   END SUBROUTINE trc_ini
+   END SUBROUTINE trc_init
 
 #else
@@ -169,8 +178,12 @@
    !!----------------------------------------------------------------------
 CONTAINS
-   SUBROUTINE trc_ini                      ! Dummy routine   
-   END SUBROUTINE trc_ini
+   SUBROUTINE trc_init                      ! Dummy routine   
+   END SUBROUTINE trc_init
 #endif
 
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trcini
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcnam.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcnam.F90	(revision 2528)
@@ -0,0 +1,209 @@
+MODULE trcnam
+   !!======================================================================
+   !!                       ***  MODULE trcnam  ***
+   !! TOP :   Read and print options for the passive tracer run (namelist)
+   !!======================================================================
+   !! History :    -   !  1996-11  (M.A. Foujols, M. Levy)  original code
+   !!              -   !  1998-04  (M.A Foujols, L. Bopp) ahtrb0 for isopycnal mixing
+   !!              -   !  1999-10  (M.A. Foujols, M. Levy) separation of sms
+   !!              -   !  2000-07  (A. Estublier) add TVD and MUSCL : Tests on ndttrc
+   !!              -   !  2000-11  (M.A Foujols, E Kestenare) trcrat, ahtrc0 and aeivtr0
+   !!              -   !  2001-01 (E Kestenare) suppress ndttrc=1 for CEN2 and TVD schemes
+   !!             1.0  !  2005-03 (O. Aumont, A. El Moussaoui) F90
+   !!----------------------------------------------------------------------
+#if defined key_top
+   !!----------------------------------------------------------------------
+   !!   'key_top'                                                TOP models
+   !!----------------------------------------------------------------------
+   !!   trc_nam    :  Read and print options for the passive tracer run (namelist)
+   !!----------------------------------------------------------------------
+   USE oce_trc
+   USE trc
+   USE trcnam_trp        ! Transport namelist
+   USE trcnam_lobster    ! LOBSTER namelist
+   USE trcnam_pisces     ! PISCES namelist
+   USE trcnam_cfc        ! CFC SMS namelist
+   USE trcnam_c14b       ! C14 SMS namelist
+   USE trcnam_my_trc     ! MY_TRC SMS namelist
+   USE in_out_manager    ! I/O manager
+   USE trdmod_trc_oce
+
+   IMPLICIT NONE
+   PRIVATE 
+
+   PUBLIC trc_nam      ! called in trcini
+
+   !! * Substitutions
+#  include "top_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE trc_nam
+      !!---------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_nam  ***
+      !!
+      !! ** Purpose :   READ and PRINT options for the passive tracer run (namelist) 
+      !!
+      !! ** Method  : - read passive tracer namelist 
+      !!              - read namelist of each defined SMS model
+      !!                ( (LOBSTER, PISCES, CFC, MY_TRC )
+      !!---------------------------------------------------------------------
+      INTEGER ::  jn
+
+      ! Definition of a tracer as a structure
+      TYPE PTRACER
+         CHARACTER(len = 20)  :: clsname  !: short name
+         CHARACTER(len = 80 ) :: cllname  !: long name
+         CHARACTER(len = 20 ) :: clunit   !: unit
+         LOGICAL              :: llinit   !: read in a file or not
+         LOGICAL              :: llsave   !: save the tracer or not
+      END TYPE PTRACER
+
+      TYPE(PTRACER) , DIMENSION(jptra) :: sn_tracer
+
+      !!
+      NAMELIST/namtrc/    nn_dttrc, nn_writetrc, ln_rsttr, nn_rsttr, &
+                          cn_trcrst_in, cn_trcrst_out, sn_tracer
+#if defined key_trdmld_trc  || defined key_trdtrc
+      NAMELIST/namtrc_trd/ nn_trd_trc, nn_ctls_trc, rn_ucf_trc, &
+                         ln_trdmld_trc_restart, ln_trdmld_trc_instant, &
+                         cn_trdrst_trc_in, cn_trdrst_trc_out, ln_trdtrc
+#endif
+
+      !!---------------------------------------------------------------------
+
+      IF(lwp) WRITE(numout,*) 'trc_nam : read the passive tracer namelists'
+      IF(lwp) WRITE(numout,*) '~~~~~~~'
+
+      CALL ctl_opn( numnat, 'namelist_top', 'OLD', 'FORMATTED', 'SEQUENTIAL', 1, numout, .FALSE. )
+
+      ! Namelist nattrc (files)
+      ! ----------------------------------------------
+      nn_dttrc    = 1                 ! default values
+      nn_writetrc = 10      
+      ln_rsttr    = .FALSE.
+      nn_rsttr    =  0
+      cn_trcrst_in  = 'restart_trc'
+      cn_trcrst_out = 'restart_trc'
+      DO jn = 1, jptra
+         WRITE(ctrcnm(jn),'("TR_",I1)'           ) jn
+         WRITE(ctrcnl(jn),'("TRACER NUMBER ",I1)') jn
+         ctrcun(jn) = 'mmole/m3'
+         lutini(jn) = .FALSE. 
+         lutsav(jn) = .TRUE. 
+      END DO
+
+      REWIND( numnat )               ! read nattrc
+      READ  ( numnat, namtrc )
+
+      DO jn = 1, jptra
+         ctrcnm(jn) = sn_tracer(jn)%clsname
+         ctrcnl(jn) = sn_tracer(jn)%cllname
+         ctrcun(jn) = sn_tracer(jn)%clunit
+         lutini(jn) = sn_tracer(jn)%llinit
+         lutsav(jn) = sn_tracer(jn)%llsave
+      END DO
+
+
+      IF(lwp) THEN                   ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : namtrc'
+         WRITE(numout,*) '    time step freq. for pass. trac. nn_dttrc             = ', nn_dttrc
+         WRITE(numout,*) '    frequency of outputs for passive tracers nn_writetrc = ', nn_writetrc  
+         WRITE(numout,*) '    restart LOGICAL for passive tr. ln_rsttr             = ', ln_rsttr
+         WRITE(numout,*) '    control of time step for p. tr. nn_rsttr             = ', nn_rsttr
+         WRITE(numout,*) ' '
+         DO jn = 1, jptra
+            WRITE(numout,*) '   tracer nb             : ', jn 
+            WRITE(numout,*) '   short name            : ', TRIM(ctrcnm(jn))
+            WRITE(numout,*) '   long name             : ', TRIM(ctrcnl(jn))
+            WRITE(numout,*) '   unit                  : ', TRIM(ctrcun(jn))
+            WRITE(numout,*) '   initial value in FILE : ', lutini(jn) 
+            WRITE(numout,*) ' '
+         END DO
+      ENDIF
+
+      rdttrc(:) = rdttra(:) * FLOAT( nn_dttrc )   ! vertical profile of passive tracer time-step
+  
+      IF(lwp) WRITE(numout,*) 
+      IF(lwp) WRITE(numout,*) '    Passive Tracer  time step    rdttrc  = ', rdttrc(1)
+      IF(lwp) WRITE(numout,*) 
+
+#if defined key_trdmld_trc || defined key_trdtrc
+      nn_trd_trc  = 20
+      nn_ctls_trc =  9
+      rn_ucf_trc   =  1.
+      ln_trdmld_trc_instant = .TRUE.
+      ln_trdmld_trc_restart =.FALSE.
+      cn_trdrst_trc_in  = "restart_mld_trc"
+      cn_trdrst_trc_out = "restart_mld_trc"
+      ln_trdtrc(:) = .FALSE.
+
+      REWIND( numnat )               !  namelist namtoptrd : passive tracer trends diagnostic
+      READ  ( numnat, namtrc_trd )
+
+     IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) ' trd_mld_trc_init : read namelist namtrc_trd                    '
+         WRITE(numout,*) ' ~~~~~~~~~~~~~~~~                                               '
+         WRITE(numout,*) '   * frequency of trends diagnostics   nn_trd_trc             = ', nn_trd_trc
+         WRITE(numout,*) '   * control surface type              nn_ctls_trc            = ', nn_ctls_trc
+         WRITE(numout,*) '   * restart for ML diagnostics        ln_trdmld_trc_restart  = ', ln_trdmld_trc_restart
+         WRITE(numout,*) '   * flag to diagnose trends of                                 '
+         WRITE(numout,*) '     instantantaneous or mean ML T/S   ln_trdmld_trc_instant  = ', ln_trdmld_trc_instant
+         WRITE(numout,*) '   * unit conversion factor            rn_ucf_trc             = ', rn_ucf_trc
+         DO jn = 1, jptra
+            IF( ln_trdtrc(jn) ) WRITE(numout,*) '    compute ML trends for tracer number :', jn
+         END DO
+      ENDIF
+#endif
+
+      ! namelist of transport
+      ! ---------------------
+      CALL trc_nam_trp
+
+
+      ! namelist of SMS
+      ! ---------------      
+      IF( lk_lobster ) THEN   ;   CALL trc_nam_lobster      ! LOBSTER bio-model
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          LOBSTER not used'
+      ENDIF
+
+      IF( lk_pisces  ) THEN   ;   CALL trc_nam_pisces      ! PISCES  bio-model
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          PISCES not used'
+      ENDIF
+
+      IF( lk_cfc     ) THEN   ;   CALL trc_nam_cfc         ! CFC     tracers
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          CFC not used'
+      ENDIF
+
+      IF( lk_c14b     ) THEN   ;   CALL trc_nam_c14b         ! C14 bomb     tracers
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          C14 not used'
+      ENDIF
+
+      IF( lk_my_trc  ) THEN   ;   CALL trc_nam_my_trc      ! MY_TRC  tracers
+      ELSE                    ;   IF(lwp) WRITE(numout,*) '          MY_TRC not used'
+      ENDIF
+      !
+   END SUBROUTINE trc_nam
+
+#else
+   !!----------------------------------------------------------------------
+   !!  Dummy module :                                     No passive tracer
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE trc_nam                      ! Empty routine   
+   END SUBROUTINE trc_nam
+#endif
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!======================================================================
+END MODULE  trcnam
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcrst.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcrst.F90	(revision 2528)
@@ -25,6 +25,7 @@
    USE oce_trc
    USE trc
-   USE trctrp_lec
+   USE trcnam_trp
    USE lib_mpp
+   USE lib_fortran
    USE iom
    USE trcrst_cfc      ! CFC      
@@ -33,7 +34,5 @@
    USE trcrst_c14b     ! C14 bomb restart
    USE trcrst_my_trc   ! MY_TRC   restart
-#if defined key_off_tra
-    USE daymod
-#endif
+   USE daymod
    IMPLICIT NONE
    PRIVATE
@@ -47,9 +46,4 @@
    !! * Substitutions
 #  include "top_substitute.h90"
-   !!----------------------------------------------------------------------
-   !! NEMO/TOP 1.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
    
 CONTAINS
@@ -67,22 +61,23 @@
       !!----------------------------------------------------------------------
       !
-# if ! defined key_off_tra
-      IF( kt == nit000 ) lrst_trc = .FALSE. 
-# else
-      IF( kt == nit000 ) THEN
-        lrst_trc = .FALSE. 
-        nitrst = nitend  
-      ENDIF
-
-      IF( MOD( kt - 1, nstock ) == 0 ) THEN
-         ! we use kt - 1 and not kt - nit000 to keep the same periodicity from the beginning of the experiment
-         nitrst = kt + nstock - 1                  ! define the next value of nitrst for restart writing
-         IF( nitrst > nitend )   nitrst = nitend   ! make sure we write a restart at the end of the run
-      ENDIF
-# endif
-     ! to get better performances with NetCDF format:
-     ! we open and define the tracer restart file one tracer time step before writing the data (-> at nitrst - 2*ndttrc + 1)
-     ! except if we write tracer restart files every tracer time step or if a tracer restart file was writen at nitend - 2*ndttrc + 1
-     IF( kt == nitrst - 2*ndttrc + 1 .OR. nstock == ndttrc .OR. ( kt == nitend - ndttrc + 1 .AND. .NOT. lrst_trc ) ) THEN
+      IF( lk_offline ) THEN
+         IF( kt == nit000 ) THEN
+            lrst_trc = .FALSE.
+            nitrst = nitend
+         ENDIF
+
+         IF( MOD( kt - 1, nstock ) == 0 ) THEN
+            ! we use kt - 1 and not kt - nit000 to keep the same periodicity from the beginning of the experiment
+            nitrst = kt + nstock - 1                  ! define the next value of nitrst for restart writing
+            IF( nitrst > nitend )   nitrst = nitend   ! make sure we write a restart at the end of the run
+         ENDIF
+      ELSE
+         IF( kt == nit000 ) lrst_trc = .FALSE.
+      ENDIF
+
+      ! to get better performances with NetCDF format:
+      ! we open and define the tracer restart file one tracer time step before writing the data (-> at nitrst - 2*nn_dttrc + 1)
+      ! except if we write tracer restart files every tracer time step or if a tracer restart file was writen at nitend - 2*nn_dttrc + 1
+      IF( kt == nitrst - 2*nn_dttrc + 1 .OR. nstock == nn_dttrc .OR. ( kt == nitend - nn_dttrc + 1 .AND. .NOT. lrst_trc ) ) THEN
          ! beware of the format used to write kt (default is i8.8, that should be large enough)
          IF( nitrst > 1.0e9 ) THEN   ;   WRITE(clkt,*       ) nitrst
@@ -106,6 +101,4 @@
       !!----------------------------------------------------------------------
       INTEGER  ::  jn     
-      INTEGER  ::  iarak0 
-      REAL(wp) ::  zarak0
       INTEGER  ::  jlibalt = jprstlib
       LOGICAL  ::  llok
@@ -128,17 +121,5 @@
       ! Time domain : restart
       ! ---------------------
-      CALL trc_rst_cal( nittrc000, 'READ' )   ! calendar
-
-      IF( ln_trcadv_cen2 .OR. ln_trcadv_tvd ) THEN   ;   iarak0 = 1
-      ELSE                                           ;   iarak0 = 0
-      ENDIF
-      CALL iom_get( numrtr, 'arak0', zarak0 )
-
-      IF( iarak0 /= NINT( zarak0 ) )   &                           ! Control of the scheme
-         & CALL ctl_stop( ' ===>>>> : problem with advection scheme', &
-         & ' it must be the same type for both restart and previous run', &
-         & ' centered or euler '  )
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) '    arakawa option      : ', NINT( zarak0 )
+      CALL trc_rst_cal( nit000, 'READ' )   ! calendar
 
       ! READ prognostic variables and computes diagnostic variable
@@ -175,10 +156,5 @@
 
       CALL trc_rst_cal( kt, 'WRITE' )   ! calendar
-
-      IF( ln_trcadv_cen2 .OR. ln_trcadv_tvd ) THEN   ;   zarak0 = 1.
-      ELSE                                           ;   zarak0 = 0.
-      ENDIF
-      CALL iom_rstput( kt, nitrst, numrtw, 'arak0', zarak0 )
-
+      CALL iom_rstput( kt, nitrst, numrtw, 'rdttrc1', rdttrc(1) )   ! surface passive tracer time step
       ! prognostic variables 
       ! -------------------- 
@@ -222,6 +198,6 @@
       !!
       !!   According to namelist parameter nrstdt,
-      !!       nrsttr = 0  no control on the date (nittrc000 is  arbitrary).
-      !!       nrsttr = 1  we verify that nit000 is equal to the last
+      !!       nn_rsttr = 0  no control on the date (nit000 is  arbitrary).
+      !!       nn_rsttr = 1  we verify that nit000 is equal to the last
       !!                   time step of previous run + 1.
       !!       In both those options, the  exact duration of the experiment
@@ -230,5 +206,5 @@
       !!       This is valid is the time step has remained constant.
       !!
-      !!       nrsttr = 2  the duration of the experiment in days (adatrj)
+      !!       nn_rsttr = 2  the duration of the experiment in days (adatrj)
       !!                    has been stored in the restart file.
       !!----------------------------------------------------------------------
@@ -236,8 +212,6 @@
       CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
       !
-      REAL(wp) ::  zkt
-#if defined key_off_tra
+      REAL(wp) ::  zkt, zrdttrc1
       REAL(wp) ::  zndastp
-#endif
 
       ! Time domain : restart
@@ -250,38 +224,43 @@
             WRITE(numout,*) '   previous time-step                               : ', NINT( zkt )
             WRITE(numout,*) ' *** restart option'
-            SELECT CASE ( nrsttr )
-            CASE ( 0 )   ;   WRITE(numout,*) ' nrsttr = 0 : no control of nittrc000'
-            CASE ( 1 )   ;   WRITE(numout,*) ' nrsttr = 1 : no control the date at nit000 (use ndate0 read in the namelist)'
-            CASE ( 2 )   ;   WRITE(numout,*) ' nrsttr = 2 : calendar parameters read in restart'
+            SELECT CASE ( nn_rsttr )
+            CASE ( 0 )   ;   WRITE(numout,*) ' nn_rsttr = 0 : no control of nit000'
+            CASE ( 1 )   ;   WRITE(numout,*) ' nn_rsttr = 1 : no control the date at nit000 (use ndate0 read in the namelist)'
+            CASE ( 2 )   ;   WRITE(numout,*) ' nn_rsttr = 2 : calendar parameters read in restart'
             END SELECT
             WRITE(numout,*)
          ENDIF
          ! Control of date 
-         IF( nittrc000  - NINT( zkt ) /= 1 .AND.  nrsttr /= 0 )                                  &
+         IF( nit000  - NINT( zkt ) /= 1 .AND.  nn_rsttr /= 0 )                                  &
             &   CALL ctl_stop( ' ===>>>> : problem with nit000 for the restart',                 &
-            &                  ' verify the restart file or rerun with nrsttr = 0 (namelist)' )
-#if defined key_off_tra
-         ! define ndastp and adatrj
-         IF ( nrsttr == 2 ) THEN
-            CALL iom_get( numrtr, 'ndastp', zndastp ) 
-            ndastp = NINT( zndastp )
-            CALL iom_get( numrtr, 'adatrj', adatrj  )
-         ELSE
-            ndastp = ndate0 - 1     ! ndate0 read in the namelist in dom_nam
-            adatrj = ( REAL( nittrc000-1, wp ) * rdttra(1) ) / rday
-            ! note this is wrong if time step has changed during run
+            &                  ' verify the restart file or rerun with nn_rsttr = 0 (namelist)' )
+         IF( lk_offline ) THEN      ! set the date in offline mode
+            ! Check dynamics and tracer time-step consistency and force Euler restart if changed
+            IF( iom_varid( numrtr, 'rdttrc1', ldstop = .FALSE. ) > 0 )   THEN
+               CALL iom_get( numrtr, 'rdttrc1', zrdttrc1 )
+               IF( zrdttrc1 /= rdttrc(1) )   neuler = 0
+            ENDIF
+            !                          ! define ndastp and adatrj
+            IF ( nn_rsttr == 2 ) THEN
+               CALL iom_get( numrtr, 'ndastp', zndastp ) 
+               ndastp = NINT( zndastp )
+               CALL iom_get( numrtr, 'adatrj', adatrj  )
+            ELSE
+               ndastp = ndate0 - 1     ! ndate0 read in the namelist in dom_nam
+               adatrj = ( REAL( nit000-1, wp ) * rdttra(1) ) / rday
+               ! note this is wrong if time step has changed during run
+            ENDIF
+            !
+            IF(lwp) THEN
+              WRITE(numout,*) ' *** Info used values : '
+              WRITE(numout,*) '   date ndastp                                      : ', ndastp
+              WRITE(numout,*) '   number of elapsed days since the begining of run : ', adatrj
+              WRITE(numout,*)
+            ENDIF
+            !
+            CALL day_init          ! compute calendar
+            !
          ENDIF
          !
-         IF(lwp) THEN
-           WRITE(numout,*) ' *** Info used values : '
-           WRITE(numout,*) '   date ndastp                                      : ', ndastp
-           WRITE(numout,*) '   number of elapsed days since the begining of run : ', adatrj
-           WRITE(numout,*)
-         ENDIF
-         !
-         CALL day_init          ! compute calendar
-         !
-#endif
-
       ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN
          !
@@ -291,5 +270,4 @@
             IF(lwp) WRITE(numout,*) '~~~~~~~'
          ENDIF
-         ! calendar control
          CALL iom_rstput( kt, nitrst, numrtw, 'kt'     , REAL( kt    , wp) )   ! time-step
          CALL iom_rstput( kt, nitrst, numrtw, 'ndastp' , REAL( ndastp, wp) )   ! date
@@ -308,7 +286,7 @@
       !!----------------------------------------------------------------------
 
-      INTEGER  :: ji, jj, jk, jn
+      INTEGER  :: jn
       REAL(wp) :: zdiag_var, zdiag_varmin, zdiag_varmax, zdiag_tot
-      REAL(wp) :: zder, zvol
+      REAL(wp) :: zder
       !!----------------------------------------------------------------------
 
@@ -322,19 +300,9 @@
       zdiag_tot = 0.e0
       DO jn = 1, jptra
-         zdiag_var    = 0.e0
-         zdiag_varmin = 0.e0
-         zdiag_varmax = 0.e0
-         DO jk = 1, jpk
-            DO jj = 1, jpj
-               DO ji = 1, jpi
-                  zvol = cvol(ji,jj,jk)
-#  if defined key_off_degrad
-                  zvol = zvol * facvol(ji,jj,jk)
+#  if defined key_degrad
+         zdiag_var = glob_sum( trn(:,:,:,jn) * cvol(:,:,:) * facvol(:,:,:) )
+#  else
+         zdiag_var = glob_sum( trn(:,:,:,jn) * cvol(:,:,:)  )
 #  endif
-                  zdiag_var = zdiag_var + trn(ji,jj,jk,jn) * zvol
-               END DO
-            END DO
-         END DO
-         
          zdiag_varmin = MINVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
          zdiag_varmax = MAXVAL( trn(:,:,:,jn), mask= ((tmask*SPREAD(tmask_i,DIM=3,NCOPIES=jpk).NE.0.)) )
@@ -342,5 +310,4 @@
             CALL mpp_min( zdiag_varmin )      ! min over the global domain
             CALL mpp_max( zdiag_varmax )      ! max over the global domain
-            CALL mpp_sum( zdiag_var    )      ! sum over the global domain
          END IF
          zdiag_tot = zdiag_tot + zdiag_var
@@ -369,4 +336,8 @@
 #endif
 
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$ 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trcrst
Index: trunk/NEMOGCM/NEMO/TOP_SRC/trcsms.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/trcsms.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/trcsms.F90	(revision 2528)
@@ -28,7 +28,7 @@
 
    !!----------------------------------------------------------------------
-   !! NEMO/TOP 2.0 , LOCEAN-IPSL (2007) 
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -48,5 +48,5 @@
       !!---------------------------------------------------------------------
 
-      IF ( MOD(kt,ndttrc) /= 0) RETURN      ! this ROUTINE is called only every ndttrc time step
+      IF ( MOD( kt, nn_dttrc) /= 0 ) RETURN      ! this ROUTINE is called only every ndttrc time step
 
       IF( lk_lobster )   CALL trc_sms_lobster( kt )    ! main program of LOBSTER
